<?php
/*
Plugin Name: Avalicious!
Plugin URI: http://beta.void-star.net/projects/avalicious/
Description: A plugin for integrating LiveJournal and LiveJournal-style clones into WordPress comment posts. Based on <a href="http://alltrees.org/Wordpress/#ALA">Also LJ Avatar</a>.
Version: 1.1
Author: Alis Dee
Author URI: http://void-star.net
License: GPL (http://www.gnu.org/licenses/gpl.html)
*/
// yay for debugging:  mail( 'email', 'subject', print_r( get_defined_vars(), true ) );

function dangaicon( $avatar ) {
  //global $comment;
  $_JOURNALS = array(
    'livejournal.com',
    'insanejournal.com',
    'journalfen.net',
    'deadjournal.com',
    'greatestjournal.com',
    'inksome.com',
    'dreamwidth.org',
  );
  $jurl = ''; $jname = '';
  
  // extract the height/width specified in the theme, if any, to use as size
  $size = ( preg_match( "/height='([0-9]*)'/", $avatar, $m ) || preg_match( '/height="([0-9]*)"/', $avatar, $m ) )
        ? $m[1]
        : 80;

  // get our user's url...
  $auth_url = get_comment_author_url();

  // if the url matches an LJ configuration, get our journal and login name
  // if we dont get this far, we're good to return
  foreach( $_JOURNALS as $j ) {
    if( preg_match( "/$j/", $auth_url ) )
      $jurl = $j;
  }
  if( !$jurl )
    { return $avatar; }
  
  if( preg_match( "#http://([a-z0-9_-]*)\.$jurl/{0,1}~{0,1}([a-z0-9_-]{0,})/{0,1}([a-z0-9_-]{0,})#", $auth_url, $m ) )
    { $jname = empty( $m[3] ) ? !empty( $m[2] ) ? $m[2] : $m[1] : $m[3]; }

  // okay, now we've got our journal and our username... let's go!
  $jname = strtolower( $jname );

  // first, let's check our cache...
  if( file_exists( ABSPATH . '/wp-content/plugins/avalicious/danga-icons/'. $jname .'.'. $jurl ) )
    { $avatar = '<img class="avatar" src="'. get_settings( 'siteurl' ).'/wp-content/plugins/avalicious/danga-icons/'. $jname .'.'. $jurl .'" height="'. $size .'" width="'. $size .'" />'; }
  
  // if that doesn't work, download the pic and try again
  elseif( $jpic = getuserpic( $jname, $jurl ) )
    { $avatar = '<img class="avatar" src="'. $jpic .'" height="'. $size .'" width="'. $size .'" />'; }

  return $avatar;
}

// if the user parses as an LJ-clone user and does not have a pic cached, go get their default user icon (This code is by Alex Bishop)
function getuserpic( $danga_user, $danga_journal_url ) {
  $url = "http://www.$danga_journal_url/allpics.bml?user=$danga_user";

  // start curling!
  $ch = curl_init();
  curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 ); // return the data, don't echo it
  curl_setopt( $ch, CURLOPT_URL, $url ); // set our url
  $allpics = curl_exec( $ch ); // go go gadget cURL!
  curl_close( $ch );
  // end cURL
  
  // get our pic!
  preg_match( '#http://(www.|userpic.|p-userpic.|)'. $danga_journal_url .'/(userpic/){0,1}[0-9]{1,}/[0-9]{1,}#', $allpics, $pics );
  // if we got something, let's cache it
  if( $pics[0] ){
    $fp = fopen( ABSPATH . '/wp-content/plugins/avalicious/danga-icons/'. $danga_user .'.'. $danga_journal_url, 'w' );
    // start curling!
    $ch = curl_init();
    curl_setopt( $ch, CURLOPT_URL, $pics[0] ); // set our url
    curl_setopt( $ch, CURLOPT_FILE, $fp );     // set up upload location
    curl_exec( $ch );                          // go go gadget cURL!
    curl_close( $ch );
    // end cURL
    fclose( $fp );
  }

  if( file_exists( ABSPATH . '/wp-content/plugins/avalicious/danga-icons/'. $danga_user .'.'. $danga_journal_url ) )
    return get_settings( 'siteurl' ).'/wp-content/plugins/avalicious/danga-icons/'. $danga_user .'.'. $danga_journal_url;
  else
    return $pic[0];
}

// hookit!
add_filter( 'get_avatar', 'dangaicon', 9999 );
?>